#!/usr/bin/perl -I/usr/sausalito/perl
#
# $Id: update_ipalloc.pl,v 1.0.0.0 Mon 31 Dec 2007 09:33:59 PM CET mstauber Exp $
# Copyright 2006-2007 Solarspeed Ltd. and NuOnce Networks, Inc. All rights reserved.
#
# Handler which writes / updates VZ config files.
#

use CCE;
use POSIX qw(isalpha);

my $DEBUG = 0;

my $cce = new CCE('Domain' => 'base-vserver');

if ($DEBUG == 0) {
    $cce->connectfd();
}
else {
    $cce->connectuds(); # only for debugging
}

if ($DEBUG == 0) {
    ($sys_oidmasternode) = $cce->find('VserverMasterNode');
    ($ok, $VserverMasterNode) = $cce->get($sys_oidmasternode);
    $vpsid = $VserverMasterNode->{gui_list_ip};
    system("echo \"VPSID: $vpsid\" > /tmp/vpsid");
}
else {
    $vpsid = 1; # In debug mode only!
    system("echo \"VPSID-debug: $vpsid\" > /tmp/vpsid");
}

##
# IP address allocation stuff:
##

# Find the relevant objects through their vpsid in vpsIPalloc objects:
@oids = $cce->find('vpsIPalloc', {'vpsid' => $vpsid});
if ($DEBUG == 1) {
        system("echo '1st: Found $#oids IPs for this VPS' > /tmp/vpsid");
}
if ($#oids == -1) {
    if ($DEBUG == 1) {
        system("echo 'Unable to determine VPSID based on vpsIPalloc' > /tmp/vpsid");
    }
    #$cce->bye('FAIL', "[[base-vserver.unableToDetermineVPSID]]");
    #exit(1);
}
else {
    # VPSID found in CCE.
    foreach $line (@oids) {
            ($ok, $system) = $cce->get($line);
            $func = push(@ips, $system->{min});
    }
    # How many IP's we got?
    $num = $#ips;
    if ($DEBUG == 1) {
        system("echo '2nd: Found $num IPs for this VPS' > /tmp/vpsid");
    }
    # Sort the IPs:
    @sorted_ips = sort { $a cmp $b } @ips;
    # Line them up in the single string $iplist, separated by spaces:
    foreach $value (@sorted_ips) {
        if ($num > 0) {
            $iplist .= $value . ";";
            $num--;
        }
        else {
            $iplist .= $value;
        }
    }
}


# Find the relevant object through its vpsid in Vserver:
@oids = $cce->find('Vserver', {'vpsid' => $vpsid});
if ($#oids < 0) {
    $cce->bye('FAIL', "[[base-vserver.unableToDetermineVPSID]]");
    if ($DEBUG == 1) {
        system("echo 'VPSID not found in CCE.' >> /tmp/vpsid");
    }
    exit(1);
}
else {
    # get the system object
    ($sys_oid) = $cce->find('Vserver', {'vpsid' => $vpsid});
    ($ok, $vpsdata) = $cce->get($sys_oid);

    if ($ok) {

        if ($DEBUG == 1) {
            system("echo 'VPSDATA found in CCE.' >> /tmp/vpsid");
        }

        vps_write_conf(
            $vpsdata->{'vpsid'},
            $vpsdata->{'ip'},
            $iplist
        );
    }
    else {
        if ($DEBUG == 1) {
            system("echo 'VPSDATA retrieval errored out.' >> /tmp/vpsid");
        }
    }
}

sub vps_write_conf {

        my $vpsid                       = shift;
        my $ip                          = shift;
        my $iplist                      = shift;

        # Apply changes to VPS (regardless if it is running or stopped) and rewrite config:
        system("/usr/sbin/vzctl set $vpsid --ipdel all --ipadd $ip --save");

	# Add allocated extra IP addresses in one go:	
	$new_ip_list = $iplist;
	$new_ip_list =~ s/;/ /g;
	if ($DEBUG == 1) {
		system("echo \"$iplist\" > /tmp/vpsidallnew");
		system("echo \"$new_ip_list\" >> /tmp/vpsidallnew");
	}
	system("/usr/sbin/vzctl set $vpsid --ipadd \"$new_ip_list\" --save");

}

# If we're NO debugging, we delete /tmp/vpsid here:
if ($DEBUG == 0) {
    system("/in/rm -f /tmp/vpsid");
}

# We need to say 'SUCCESS' or CCE will bitch:
$cce->bye('SUCCESS');
exit(0);

