#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: update_uconf.pl, v1.1.0.1 Sat 19 Apr 2008 09:45:42 AM CEST mstauber Exp $
# Copyright 2006-2008 Solarspeed Ltd. All rights reserved.

# This constructor generates /etc/vz/uconf/000_customers.conf based from the user information
# located in CCE. This is especially important for clusters on fail overs, so that the user
# information can be inherited on the new primary after a fail-over.

#$whatami = "constructor";
$whatami = "handler";

use CCE;
my $cce = new CCE;
my $conf = '/var/lib/cobalt';

if ($whatami eq "handler") {
    $cce->connectfd();
}
else {
    $cce->connectuds();
}

# Location of the config file:
$customers_Config = "/etc/vz/uconf/000_customers.conf";
$customers_Dir = "/etc/vz/uconf";

# Config file present?
if (-e $customers_Config) {
        &main;
}
else {
	&main;
}

sub main {

    # We are not secondary in a cluster, aren't we?
    if (!-d "/vz/private") {
	$cce->bye('SUCCESS');
	exit(0);
    }
    else {
	# OK, we'e not secondary. Move on:
	&dircreate;

        @oids = $cce->find('User', {'capabilities' => 'ManageVPS'});
	if ($#oids < 0) {
    	    # Nothing found
	    system("/bin/rm -f $customers_Dir/*.uconf");
	    system("/bin/rm -f $customers_Config");
	}
	else {
	    system("/bin/rm -f $customers_Dir/*.uconf");
	    open(OUT,">$customers_Config") || die "Can't write to $customers_Config";
    	    foreach $customer_oid (@oids) {
		&getuser;
		if ($user->{'name'} ne "") {
		    print OUT "$user->{'name'}:$user->{'customer_owned_vps'}\n";
	    	    &printuser;
		}
	    }
	    close OUT;
	    system("/bin/chmod 600 $customers_Config");
	}
    }
}

sub getuser {
     ($ok, $user) = $cce->get($customer_oid);
}

sub printuser {
	open(COUT,">$customers_Dir/$user->{'name'}.uconf") || die "Can't write to $customers_Dir/$user->{'name'}.uconf";
	print COUT "name:$user->{'name'}\n";
	print COUT "capLevels:$user->{'capLevels'}\n";
	print COUT "capabilities:$user->{'capabilities'}\n";
	print COUT "customer_email:$user->{'customer_email'}\n";
	print COUT "uiRights:$user->{'uiRights'}\n";
	print COUT "crypt_password:$user->{'crypt_password'}\n";
	print COUT "desc_readonly:$user->{'desc_readonly'}\n";
	print COUT "customer_city:$user->{'customer_city'}\n";
	print COUT "customer_phone:$user->{'customer_phone'}\n";
	print COUT "volume:$user->{'volume'}\n";
	print COUT "customer_zip:$user->{'customer_zip'}\n";
	print COUT "md5_password:$user->{'md5_password'}\n";
	print COUT "systemAdministrator:$user->{'systemAdministrator'}\n";
	print COUT "customer_fax:$user->{'customer_fax'}\n";
	print COUT "enabled:$user->{'enabled'}\n";
	print COUT "customer_country:$user->{'customer_country'}\n";
	print COUT "description:$user->{'description'}\n";
	print COUT "customer_owned_vps:$user->{'customer_owned_vps'}\n";
	print COUT "emailDisabled:$user->{'emailDisabled'}\n";
	print COUT "localePreference:$user->{'localePreference'}\n";
	print COUT "customer_address:$user->{'customer_address'}\n";
	print COUT "noFileCheck:$user->{'noFileCheck'}\n";
	print COUT "sortName:$user->{'sortName'}\n";
	print COUT "fullName:$user->{'fullName'}\n";
	print COUT "customer_state:$user->{'customer_state'}\n";
	print COUT "shell:$user->{'shell'}\n";
	print COUT "customer_company:$user->{'customer_company'}\n";
	print COUT "site:$user->{'site'}\n";
	print COUT "stylePreference:$user->{'stylePreference'}\n";
	print COUT "ui_enabled:$user->{'ui_enabled'}\n";
	print COUT "password:$user->{'password'}\n";
	print COUT "customer_comment:\n$user->{'customer_comment'}\n";
	close COUT;
	system("/bin/chmod 600 $customers_Dir/$user->{'name'}.uconf");
}

sub dircreate {
    if (!-d "/etc/vz/uconf") {
	system("/bin/mkdir $customers_Dir");
	system("/bin/chmod 600 $customers_Dir");
	&main;
    }
}

$cce->bye('SUCCESS');
exit(0);

